/*
 * gpio.cpp
 *
 *  Created on: 25.03.2013
 *      Author: Jiri, Freescale
 */

// Vybrid RFS
/*
 echo 22 > /sys/class/gpio/export
 echo 23 > /sys/class/gpio/export
 echo 24 > /sys/class/gpio/export
 echo 25 > /sys/class/gpio/export
 echo out > /sys/class/gpio/gpio22/direction
 echo out > /sys/class/gpio/gpio23/direction
 echo out > /sys/class/gpio/gpio24/direction
 echo out > /sys/class/gpio/gpio25/direction
 */

#include "gpio.h"

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

CGpio::CGpio()
{
}

CGpio::~CGpio()
{
}

void CGpio::Init(const char * gpio)
{
    m_idev_ok = 1;
    m_ivalue = 0;
    if ((m_idev_fd = open(gpio, O_WRONLY)) < 0)
    {
        if (errno == EBUSY)
        {
            fprintf(stderr, "GPIO %s already in use\n", gpio);
        }
        m_idev_ok = 0;
    }
    else
    {
        Off(); //write(m_idev_fd, g_coff, 5);
    }

}

void CGpio::On()
{
    if (m_idev_ok)
    {
        m_ivalue = 1;
        write(m_idev_fd, g_con, 5);
    }
}

void CGpio::Off()
{
    if (m_idev_ok)
    {
        m_ivalue = 0;
        write(m_idev_fd, g_coff, 5);
    }
}

void CGpio::LedOn()
{
    if (m_idev_ok)
    {
        m_ivalue = 0;
        write(m_idev_fd, g_cled_on, 5);
    }
}

void CGpio::LedOff()
{
    if (m_idev_ok)
    {
        m_ivalue = 1;
        write(m_idev_fd, g_cled_off, 5);
    }
}

