/*
 * oobe.h
 *
 *  Created on: 09.04.2013
 *      Author: Jiri, Freescale
 */

#ifndef OOBE_H
#define OOBE_H

#include <QtGui/QWidget>
#include <QTimer>

#include "ui_oobe.h"
#include "gpio.h"
#include "GstPlayer.h"
#include "utils.h"

#include <unistd.h>
#include <sys/resource.h>
#include <sys/time.h>

//GPIOs are exported in shell and set to output
const char g_cgpio22[] = "/sys/class/gpio/gpio22/value";
const char g_cgpio23[] = "/sys/class/gpio/gpio23/value";
const char g_cgpio24[] = "/sys/class/gpio/gpio24/value";
const char g_cgpio25[] = "/sys/class/gpio/gpio25/value";

#define MODE_TOUCH 0
#define MODE_TILT 1


class oobe: public QWidget
{
Q_OBJECT

public:
    oobe(QWidget *parent = 0);
    ~oobe();

    CGpio led1, led2, led3, led4;
    void TiltOutput(char signal);


private:
    bool CheckBus();

    Ui::oobeClass ui;
    int m_accel_x, m_accel_y, m_accel_z, m_trim, m_runtime;
    int m_uptime;
    int m_led1, m_led2, m_led3, m_led4, m_mode;

    GstPlayer* gst_player;
    GstBus* gst_bus;

    QTimer* timer; //for TimerCallback()

    QDesktopWidget* qdw;
    QLabel* splash_label;
    QPixmap splash_pixmap;
    QPalette splash_palette;
    QPalette label_palette;

    bool is_playing;
    bool is_www;

private slots:
    void TimerCallback();
    void Clicked1();
    void Clicked2();
    void Clicked3();
    void Clicked4();
    void Play();
    void Stop();
    void Web();
    void CloseWeb();
    void End();
};

#endif // OOBE_H
